/*
 * Copyright (C) 2014 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.morpholim;

import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.operation.buffer.BufferParameters;
import java.awt.Color;
import java.awt.Toolkit;
import java.awt.geom.Ellipse2D;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import javax.swing.SpinnerNumberModel;
import org.jfree.chart.ChartFrame;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.LogarithmicAxis;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.CombinedDomainXYPlot;
import org.jfree.chart.plot.ValueMarker;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.DefaultXYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.opengis.referencing.crs.CoordinateReferenceSystem;
import org.thema.common.Config;
import org.thema.common.JavaLoader;
import org.thema.common.Util;
import org.thema.common.parallel.BufferForkJoinTask;
import org.thema.common.swing.PreferencesDialog;
import org.thema.data.IOFeature;
import org.thema.data.feature.DefaultFeature;


/**
 * Main frame for MorphoLim software.
 * 
 * @author Gilles Vuidel
 */
public class MorphoLim extends javax.swing.JFrame {
    
    private SortedMap<Double, Double> clusters;
    private Threshold threshold;

    /** 
     * Creates new MorphoLim Frame.
     */
    public MorphoLim() {
        initComponents();
        setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/icone64.png"))); //NOI18N
        setLocationRelativeTo(null);
        setTitle("MorphoLim - " + JavaLoader.getVersion(MorphoLim.class));
        thresholdPanel.setVisible(false);
        envelopePanel.setVisible(false);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        nextButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        envelopePanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        logEnvTextArea = new javax.swing.JTextArea();
        jLabel8 = new javax.swing.JLabel();
        startEnvButton = new javax.swing.JButton();
        radiusEnvSpinner = new javax.swing.JSpinner();
        jLabel9 = new javax.swing.JLabel();
        clusterPanel = new javax.swing.JPanel();
        coefSpinner = new javax.swing.JSpinner();
        jScrollPane1 = new javax.swing.JScrollPane();
        logTextArea = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        precisionSpinner = new javax.swing.JSpinner();
        startSpinner = new javax.swing.JSpinner();
        startButton = new javax.swing.JButton();
        selectFilePanel = new org.thema.common.swing.SelectFilePanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        saveButton = new javax.swing.JButton();
        loadButton = new javax.swing.JButton();
        thresholdPanel = new javax.swing.JPanel();
        degreSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        viewBICButton = new javax.swing.JButton();
        degreComboBox = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        viewFitButton = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        minSpinner = new javax.swing.JSpinner();
        maxSpinner = new javax.swing.JSpinner();
        jLabel7 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        infoTextArea = new javax.swing.JTextArea();
        updateButton = new javax.swing.JButton();
        jLabel11 = new javax.swing.JLabel();
        previousButton = new javax.swing.JButton();
        aboutButton = new javax.swing.JButton();
        sysButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("MorphoLim");

        nextButton.setText("Next >>");
        nextButton.setEnabled(false);
        nextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextButtonActionPerformed(evt);
            }
        });

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        logEnvTextArea.setColumns(20);
        logEnvTextArea.setRows(5);
        jScrollPane3.setViewportView(logEnvTextArea);

        jLabel8.setText("Buffer radius");

        startEnvButton.setText("Start");
        startEnvButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startEnvButtonActionPerformed(evt);
            }
        });

        radiusEnvSpinner.setModel(new javax.swing.SpinnerNumberModel(1.0d, null, null, 1.0d));

        jLabel9.setText("Step 3 : envelope generation");

        javax.swing.GroupLayout envelopePanelLayout = new javax.swing.GroupLayout(envelopePanel);
        envelopePanel.setLayout(envelopePanelLayout);
        envelopePanelLayout.setHorizontalGroup(
            envelopePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(envelopePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(envelopePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(envelopePanelLayout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(radiusEnvSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 467, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, envelopePanelLayout.createSequentialGroup()
                        .addGap(361, 361, 361)
                        .addComponent(startEnvButton, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel9))
                .addContainerGap())
        );
        envelopePanelLayout.setVerticalGroup(
            envelopePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(envelopePanelLayout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(jLabel9)
                .addGap(18, 18, 18)
                .addGroup(envelopePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(radiusEnvSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(startEnvButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 121, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(63, 63, 63))
        );

        coefSpinner.setModel(new javax.swing.SpinnerNumberModel(1.2d, 1.0d, null, 0.1d));

        logTextArea.setColumns(20);
        logTextArea.setRows(5);
        jScrollPane1.setViewportView(logTextArea);

        jLabel1.setText("Start radius");

        precisionSpinner.setModel(new javax.swing.SpinnerNumberModel(8, 2, 20, 1));

        startSpinner.setModel(new javax.swing.SpinnerNumberModel(1.0d, 0.0d, null, 1.0d));

        startButton.setText("Start");
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });

        selectFilePanel.setDescription("Layer");
        selectFilePanel.setFileDesc("Vector layer");
        selectFilePanel.setFileExts(".gpkg|.shp");

        jLabel3.setText("Buffer precision");

        jLabel2.setText("Coef");

        jLabel10.setText("Step 1 : cluster count");

        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        loadButton.setText("Load");
        loadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout clusterPanelLayout = new javax.swing.GroupLayout(clusterPanel);
        clusterPanel.setLayout(clusterPanelLayout);
        clusterPanelLayout.setHorizontalGroup(
            clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(clusterPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(clusterPanelLayout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 453, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(clusterPanelLayout.createSequentialGroup()
                        .addGroup(clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(selectFilePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 476, Short.MAX_VALUE)
                            .addGroup(clusterPanelLayout.createSequentialGroup()
                                .addGroup(clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel10)
                                    .addGroup(clusterPanelLayout.createSequentialGroup()
                                        .addComponent(jLabel1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(startSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(coefSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addGap(0, 0, Short.MAX_VALUE)))
                        .addContainerGap())
                    .addGroup(clusterPanelLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(precisionSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(startButton, javax.swing.GroupLayout.PREFERRED_SIZE, 78, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(70, 70, 70))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, clusterPanelLayout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(loadButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(saveButton)
                        .addContainerGap())))
        );
        clusterPanelLayout.setVerticalGroup(
            clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(clusterPanelLayout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(selectFilePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(startSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(coefSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(precisionSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(startButton))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 133, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(clusterPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(saveButton)
                    .addComponent(loadButton))
                .addContainerGap())
        );

        degreSpinner.setModel(new javax.swing.SpinnerNumberModel(12, 1, null, 1));
        degreSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                degreSpinnerStateChanged(evt);
            }
        });

        jLabel4.setText("Max polynomial degree");

        viewBICButton.setText("View BIC");
        viewBICButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewBICButtonActionPerformed(evt);
            }
        });

        degreComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                degreComboBoxActionPerformed(evt);
            }
        });

        jLabel5.setText("Select polynomial degree");

        viewFitButton.setText("View fit");
        viewFitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewFitButtonActionPerformed(evt);
            }
        });

        jLabel6.setText("Margin : min");

        minSpinner.setModel(new javax.swing.SpinnerNumberModel(1, 1, null, 1));

        maxSpinner.setModel(new javax.swing.SpinnerNumberModel(1000, 2, null, 1));

        jLabel7.setText("max");

        infoTextArea.setEditable(false);
        infoTextArea.setColumns(15);
        infoTextArea.setRows(2);
        jScrollPane2.setViewportView(infoTextArea);

        updateButton.setText("Update");
        updateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateButtonActionPerformed(evt);
            }
        });

        jLabel11.setText("Step 2 : threshold");

        javax.swing.GroupLayout thresholdPanelLayout = new javax.swing.GroupLayout(thresholdPanel);
        thresholdPanel.setLayout(thresholdPanelLayout);
        thresholdPanelLayout.setHorizontalGroup(
            thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(thresholdPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(thresholdPanelLayout.createSequentialGroup()
                        .addComponent(jLabel5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(degreComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(viewFitButton)
                        .addGap(101, 101, 101))
                    .addGroup(thresholdPanelLayout.createSequentialGroup()
                        .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel7)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(maxSpinner)
                            .addComponent(minSpinner, javax.swing.GroupLayout.DEFAULT_SIZE, 74, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(updateButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane2))
                    .addGroup(thresholdPanelLayout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(degreSpinner)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(viewBICButton)
                        .addGap(123, 123, 123))
                    .addComponent(jLabel11))
                .addGap(47, 47, 47))
        );
        thresholdPanelLayout.setVerticalGroup(
            thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(thresholdPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel11)
                .addGap(24, 24, 24)
                .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(degreSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(viewBICButton))
                .addGap(39, 39, 39)
                .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(degreComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(viewFitButton))
                .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(thresholdPanelLayout.createSequentialGroup()
                        .addGap(55, 55, 55)
                        .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(minSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(maxSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7))
                        .addContainerGap(53, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, thresholdPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(thresholdPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(updateButton))
                        .addGap(49, 49, 49))))
        );

        previousButton.setText("<< Previous");
        previousButton.setEnabled(false);
        previousButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                previousButtonActionPerformed(evt);
            }
        });

        aboutButton.setText("About");
        aboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutButtonActionPerformed(evt);
            }
        });

        sysButton.setText("System");
        sysButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sysButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(closeButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(sysButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(aboutButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(previousButton)
                .addGap(29, 29, 29)
                .addComponent(nextButton)
                .addContainerGap())
            .addComponent(clusterPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(thresholdPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(envelopePanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(clusterPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(nextButton)
                    .addComponent(closeButton)
                    .addComponent(previousButton)
                    .addComponent(aboutButton)
                    .addComponent(sysButton))
                .addContainerGap())
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addComponent(thresholdPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(62, Short.MAX_VALUE)))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addComponent(envelopePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(76, Short.MAX_VALUE)))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
        startButton.setEnabled(false);
        new Thread(new Runnable() {
            @Override
            public void run() {   
                try {
                    File f = selectFilePanel.getSelectedFile();
                    int precision = ((Number)precisionSpinner.getValue()).intValue();
                    double radius = ((Number)startSpinner.getValue()).doubleValue();
                    double coef = ((Number)coefSpinner.getValue()).doubleValue();
                    
                    clusters = Cli.calcClusters(f, radius, coef, precision, new Appendable() {
                        @Override
                        public Appendable append(CharSequence csq) throws IOException {
                            logTextArea.append(csq.toString());
                            return this;
                        }
                        @Override
                        public Appendable append(CharSequence csq, int start, int end) throws IOException {
                            return append(csq.subSequence(start, end));
                        }
                        @Override
                        public Appendable append(char c) throws IOException {
                            return append(String.valueOf(c));
                        }
                    });
                    
                } catch (OutOfMemoryError er) {
                    Logger.getLogger(MorphoLim.class.getName()).log(Level.SEVERE, null, er);
                    logTextArea.append("Not enough memory ! \n" + er.getLocalizedMessage());
                    return;
                } catch (IOException ex) {
                    Logger.getLogger(MorphoLim.class.getName()).log(Level.SEVERE, null, ex);
                    logTextArea.append(ex.getLocalizedMessage());
                    return;
                } finally {
                    startButton.setEnabled(true);
                }
                
                nextButton.setEnabled(true);

            }}).start();
}//GEN-LAST:event_startButtonActionPerformed

    private void nextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextButtonActionPerformed
        if(clusterPanel.isVisible()) {
            clusterPanel.setVisible(false);
            thresholdPanel.setVisible(true);
            previousButton.setEnabled(true);
            threshold = new Threshold(clusters);
            minSpinner.setValue((int)threshold.getMinMargin());
            maxSpinner.setValue((int)threshold.getMaxMargin());
            degreSpinner.setModel(new SpinnerNumberModel(clusters.size()-3 > 12 ? 12 : clusters.size()-3, 1, clusters.size()-3, 1));
            degreSpinnerStateChanged(null);
        } else if(thresholdPanel.isVisible()) {
            thresholdPanel.setVisible(false);
            envelopePanel.setVisible(true);
            nextButton.setEnabled(false);
            radiusEnvSpinner.setValue(threshold.getThreshold((Integer)degreComboBox.getSelectedItem()) / 2);
        }
    }//GEN-LAST:event_nextButtonActionPerformed

    private void viewBICButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewBICButtonActionPerformed
        
        List<Double> bic = threshold.getBICs();
        XYSeries serie = new XYSeries("BIC");
        for(int i = 0; i < bic.size(); i++) {
            serie.add(i+1, bic.get(i));
        }
        CombinedDomainXYPlot plot = new CombinedDomainXYPlot(
                new NumberAxis("Degre"));

        XYPlot splot = new XYPlot(new XYSeriesCollection(serie),
                new NumberAxis("Degre"), new NumberAxis("BIC"),
                new XYLineAndShapeRenderer());

        plot.add(splot);

        List<Double> r2 = threshold.getR2s();
        serie = new XYSeries("R2");
        for(int i = 0; i < r2.size(); i++) {
            serie.add(i+1, r2.get(i));
        }
        splot = new XYPlot(new XYSeriesCollection(serie),
                new NumberAxis("Degre"), new NumberAxis("R2"),
                new XYLineAndShapeRenderer());

        plot.add(splot);

        JFreeChart chart = new JFreeChart("", plot);

        ChartUtilities.applyCurrentTheme(chart);
        ChartFrame frm = new ChartFrame("BIC - R2", chart);

        frm.pack();
        frm.setVisible(true);
    }//GEN-LAST:event_viewBICButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        System.exit(0);
    }//GEN-LAST:event_closeButtonActionPerformed

    private void viewFitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewFitButtonActionPerformed
        int deg = (Integer)degreComboBox.getSelectedItem();
        DefaultXYDataset dataset = new DefaultXYDataset();
        dataset.addSeries("Empirical", new double[][] {
            exp(threshold.getClusterCurve().getX()),
            exp(threshold.getClusterCurve().getY()),
        });
        dataset.addSeries("Fit", new double[][] {
            exp(threshold.getEstimCurve(deg).getX()),
            exp(threshold.getEstimCurve(deg).getY()),
        });
        dataset.addSeries("MaxCurv", new double[][] {
            exp(threshold.getMaxCurvature(deg).getX()),
            exp(threshold.getMaxCurvature(deg).getY()),
        });
        CombinedDomainXYPlot plot = new CombinedDomainXYPlot(
                new LogarithmicAxis("Distance"));

        XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer(true, false);
        XYPlot splot = new XYPlot(dataset, new LogarithmicAxis("Distance"), new LogarithmicAxis("Nb Cluster"),
                renderer);
        renderer.setSeriesLinesVisible(2, false);
        renderer.setSeriesShapesVisible(2, true);
        renderer.setSeriesShape(2, new Ellipse2D.Double(-2, -2, 4, 4));
        plot.add(splot);

        ValueMarker minMarker = new ValueMarker(threshold.getMinMargin());
        minMarker.setPaint(Color.orange);
        splot.addDomainMarker(minMarker);
        ValueMarker maxMarker = new ValueMarker(threshold.getMaxMargin());
        maxMarker.setPaint(Color.orange);
        splot.addDomainMarker(maxMarker);

        dataset = new DefaultXYDataset();
        dataset.addSeries("Curvature", new double[][] {
            exp(threshold.getCurvature(deg).getX()),
            threshold.getCurvature(deg).getY()
        });

        splot = new XYPlot(dataset, new LogarithmicAxis("Distance"), new NumberAxis("Curvature"),
                new XYLineAndShapeRenderer(true, false));
        plot.add(splot);
        splot.addDomainMarker(minMarker);
        splot.addDomainMarker(maxMarker);
        ValueMarker zeroMarker = new ValueMarker(0);
        zeroMarker.setPaint(Color.BLACK);
        splot.addRangeMarker(zeroMarker);
        JFreeChart chart = new JFreeChart("", plot);

        ChartUtilities.applyCurrentTheme(chart);

        ChartFrame frm = new ChartFrame("Curve fitting - Deg " + deg, chart);
        frm.pack();
        frm.setVisible(true);
    }//GEN-LAST:event_viewFitButtonActionPerformed

    private void previousButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_previousButtonActionPerformed
        if(thresholdPanel.isVisible()) {
            clusterPanel.setVisible(true);
            thresholdPanel.setVisible(false);
            previousButton.setEnabled(false);
        } else if(envelopePanel.isVisible()) {
            thresholdPanel.setVisible(true);
            envelopePanel.setVisible(false);
            nextButton.setEnabled(true);
        }
}//GEN-LAST:event_previousButtonActionPerformed

    private void degreComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_degreComboBoxActionPerformed
        updateButtonActionPerformed(evt);
    }//GEN-LAST:event_degreComboBoxActionPerformed

    private void updateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateButtonActionPerformed
        threshold.setMargin(((Number)minSpinner.getValue()).doubleValue(),
                ((Number)maxSpinner.getValue()).doubleValue());
        int deg = (Integer)degreComboBox.getSelectedItem();
        double x = threshold.getThreshold(deg);
        double curv = threshold.getCurvature(deg).getValue(Math.log(x));
        infoTextArea.setText(String.format("Threshold : %g\nCurvature : %g", x, curv));
    }//GEN-LAST:event_updateButtonActionPerformed

    private void startEnvButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startEnvButtonActionPerformed
        startButton.setEnabled(false);
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ArrayList<Geometry> geoms = new ArrayList<>();
                    File f = selectFilePanel.getSelectedFile();
                    CoordinateReferenceSystem crs = IOFeature.getCRS(f);

                    List<DefaultFeature> features = IOFeature.loadFeatures(f);
                    for(DefaultFeature fe : features) {
                        geoms.add(fe.getGeometry());
                    }

                    Geometry initGeom;
                    Geometry bufGeom, envGeom;
                    initGeom = new GeometryFactory().buildGeometry(geoms);
                    logEnvTextArea.append(initGeom.getEnvelopeInternal()+"\n");
                    logEnvTextArea.append(initGeom.getNumPoints() + " points\n");
                    
                    double radius = (Double)radiusEnvSpinner.getValue();
                    long start = System.currentTimeMillis();
                    logEnvTextArea.append("Positive buffer...\n");
                    bufGeom = BufferForkJoinTask.threadedBuffer(initGeom, radius);

                    // Store buffer
                    String baseName = f.getName().substring(0, f.getName().length()-4);
                    saveGeom(bufGeom, new File(f.getParent(), baseName + "-buf-" + radius + ".gpkg"), crs);

                    // TODO le buffer négatif n'a pas besoin d'union
                    logEnvTextArea.append("Negative buffer...\n");
                    envGeom = BufferForkJoinTask.threadedBuffer(bufGeom, -radius);

                    logEnvTextArea.append((System.currentTimeMillis() - start)/1000 + " sec\n");

                    // Store envelope
                    saveGeom(envGeom, new File(f.getParent(), baseName + "-env-" + radius + ".gpkg"), crs);

                    logEnvTextArea.append("Shapefile saved.\n");

                } catch (OutOfMemoryError er) {
                    Logger.getLogger(MorphoLim.class.getName()).log(Level.SEVERE, null, er);
                    logEnvTextArea.append("Not enough memory ! \n" + er.getLocalizedMessage());
                    return;
                } catch (Exception ex) {
                    Logger.getLogger(MorphoLim.class.getName()).log(Level.SEVERE, null, ex);
                    logEnvTextArea.append(ex.getLocalizedMessage());
                    return;
                }
                startButton.setEnabled(true);
            }}).start();
}//GEN-LAST:event_startEnvButtonActionPerformed

    private void degreSpinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_degreSpinnerStateChanged
        threshold.calcThreshold((Integer)degreSpinner.getValue());

        if(degreComboBox.getModel().getSize() != (Integer)degreSpinner.getValue()) {
            DefaultComboBoxModel model = new DefaultComboBoxModel();
            for(int i = 1; i<= (Integer)degreSpinner.getValue(); i++) {
                model.addElement(i);
            }
            degreComboBox.setModel(model);
        }
    }//GEN-LAST:event_degreSpinnerStateChanged

    private void aboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutButtonActionPerformed
        JOptionPane.showMessageDialog(this, "MorphoLim - " + JavaLoader.getVersion(MorphoLim.class) + "\n\nLaboratoire ThéMA UMR 6049- CNRS - Université de Franche Comté\n\nCécile Tannier, Gilles Vuidel, Pierre Frankhauser", "MorphoLim - " + JavaLoader.getVersion(MorphoLim.class), JOptionPane.PLAIN_MESSAGE);
    }//GEN-LAST:event_aboutButtonActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        File f = Util.getFileSave(".txt");
        if(f == null) {
            return;
        }
        try {
            Cli.saveCurve(selectFilePanel.getSelectedFile(), f, clusters);
        } catch(Exception ex) {
            Logger.getLogger(MorphoLim.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while saving :\n" + ex.getLocalizedMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_saveButtonActionPerformed

    private void loadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadButtonActionPerformed
        File f = Util.getFile(".txt", "Text file");
        if(f == null) {
            return;
        }
        clusters = new TreeMap<>();
        try (BufferedReader r = new BufferedReader(new FileReader(f))) {
            String line = r.readLine();
            selectFilePanel.setSelectedFile(new File(line));
            r.readLine();
            while((line = r.readLine()) != null) {
                String [] tokens = line.split("\t");
                clusters.put(Double.parseDouble(tokens[0]), Double.parseDouble(tokens[1]));
            }

            for(Double eps : clusters.keySet()) {
                logTextArea.append(eps + "\t" + clusters.get(eps) + "\n");
            }
            nextButton.setEnabled(true);
        } catch(Exception ex) {
            Logger.getLogger(MorphoLim.class.getName()).log(Level.SEVERE, null, ex);
            JOptionPane.showMessageDialog(this, "Error while loading :\n" + ex.getLocalizedMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_loadButtonActionPerformed

    private void sysButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sysButtonActionPerformed
        PreferencesDialog dlg = new PreferencesDialog(this, true);
        dlg.setProcPanelVisible(true);
        dlg.setVisible(true);
    }//GEN-LAST:event_sysButtonActionPerformed

    private void saveGeom(Geometry geom, File file, CoordinateReferenceSystem crs) throws Exception {
        List<DefaultFeature> features = new ArrayList<>();
        for(int i = 0; i < geom.getNumGeometries(); i++) {
            features.add(new DefaultFeature(i, geom.getGeometryN(i)));
        }

        IOFeature.saveFeatures(features, file, crs);
    }

    private double[] exp(double[] val) {
        double [] res = new double[val.length];
        for(int i = 0; i < val.length; i++) {
            res[i] = Math.exp(val[i]);
        }
        return res;
    }
    
    
    /**
     * Entry point of the Java program.
     * One optional parameter : "--nofork" {@link JavaLoader#NOFORK} to avoid launching another Java VM
     * @param args the command line arguments
     */
    public static void main(String args[]) throws IOException {
        
        if(args.length > 0 && !args[0].equals(JavaLoader.NOFORK)) {
            Config.setNodeClass(MorphoLim.class);
            Cli.execute(args);
            return;
        }
        
        JavaLoader.launchGUI(MorphoLim.class, args.length == 0, 1024);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton aboutButton;
    private javax.swing.JButton closeButton;
    private javax.swing.JPanel clusterPanel;
    private javax.swing.JSpinner coefSpinner;
    private javax.swing.JComboBox degreComboBox;
    private javax.swing.JSpinner degreSpinner;
    private javax.swing.JPanel envelopePanel;
    private javax.swing.JTextArea infoTextArea;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JButton loadButton;
    private javax.swing.JTextArea logEnvTextArea;
    private javax.swing.JTextArea logTextArea;
    private javax.swing.JSpinner maxSpinner;
    private javax.swing.JSpinner minSpinner;
    private javax.swing.JButton nextButton;
    private javax.swing.JSpinner precisionSpinner;
    private javax.swing.JButton previousButton;
    private javax.swing.JSpinner radiusEnvSpinner;
    private javax.swing.JButton saveButton;
    private org.thema.common.swing.SelectFilePanel selectFilePanel;
    private javax.swing.JButton startButton;
    private javax.swing.JButton startEnvButton;
    private javax.swing.JSpinner startSpinner;
    private javax.swing.JButton sysButton;
    private javax.swing.JPanel thresholdPanel;
    private javax.swing.JButton updateButton;
    private javax.swing.JButton viewBICButton;
    private javax.swing.JButton viewFitButton;
    // End of variables declaration//GEN-END:variables
    
}
